#!/usr/bin/env python
# https://tcms.engineering.redhat.com/case/101461/?from_plan=4222

import sys
import os
from dogtail.tree import *
from dogtail.procedural import *
from dogtail.rawinput import typeText
import time
from sysmon_utils import *

root_password = 'redhat'

def clickProcess(sysmon, pid=None):
    table_cell = sysmon.app.child(name=pid, roleName='table cell')
    table_cell.click()

def main():
    ret_code = 1
    try:
        sysmon = Sysmon()
        sysmon.open()
        sysmon.app.child(name='Processes', roleName='page tab').click()
        id_h = sysmon.app.child(name='ID', roleName='table column header')
        id_h.click()
        sleep(2)

        pid = openApp('gnome-terminal')
        typeIntoTerminal("sudo -i")
        keyCombo("<Enter>")
        typeIntoTerminal("echo $BASHPID > /tmp/pid_tmp")
        keyCombo("<Enter>")
        root_pid = int(open("/tmp/pid_tmp").readline())
        typeIntoTerminal("while true; do true; done")
        keyCombo("<Enter>")
        keyCombo("<Alt><Tab>")

        #have to click there somewhere already due to a bug #723448
        clickProcess(sysmon)
        sysmon.clickMenu((('View','menu'), ('Active Processes', 'check menu item')))
        keyCombo('<Esc>')
        sleep(10) # for list to reload
        clickProcess(sysmon, str(root_pid))
        sysmon.clickMenu((('Edit','menu'), ('Kill Process', 'menu item')))
        sleep(3)
        #alert = sysmon.app.child(name='Warning', roleName='alert')
        #alert.child(name='Kill Process', roleName='push button').click()
        keyCombo("<Alt>k")
        sleep(2)
        #keyCombo("<Alt><Tab>") This was necessary on F14, not on RHEL62
        typeText(root_password)
        #root.application('polkit-gnome-authentication-agent-1') \
        #    .child(name=None, roleName='password text').text = 'ubo4tore'
        sleep(2)
        #root.application('polkit-gnome-authentication-agent-1') \
        #    .child(name='Authenticate', roleName='push button').click()
        keyCombo("<Alt>a")
        sleep(15)

    except Exception:
        printException() # FAIL
        ret_code = 1

    try:
        clickProcess(sysmon, str(root_pid))
    except SearchError:
        print "PASS -- Did not find root process, that is expected! --"
        ret_code = 0
        sysmon.kill(force=True)

    if ret_code is 1:
        print "FAIL! Root process still running"
        sysmon.kill(force=True)
    return ret_code
if __name__ == "__main__": sys.exit(main())
