#!/usr/bin/env python
# https://tcms.engineering.redhat.com/case/101461/?from_plan=4222

import sys
import os
from dogtail.tree import *
from dogtail.procedural import *
import time
from sysmon_utils import *

def clickProcess(sysmon, pid=None):
    table_cell = sysmon.app.child(name=pid, roleName='table cell')
    table_cell.click()

def main():
    ret_code = 0
    try:
        sysmon = Sysmon()
        sysmon.open()
        sysmon.app.child(name='Processes', roleName='page tab').click()
        id_h = sysmon.app.child(name='ID', roleName='table column header')
        id_h.click()
        sleep(2)

        pid = openApp('gnome-terminal')
        typeIntoTerminal("sudo -i")
        keyCombo("<Enter>")
        typeIntoTerminal("echo $BASHPID > /tmp/pid_tmp")
        keyCombo("<Enter>")
        root_pid = int(open("/tmp/pid_tmp").readline()) # read the PID of root p.
        typeIntoTerminal("while true; do true; done") # make it go 100%
        keyCombo("<Enter>") # so that it appears in Active processes
        keyCombo("<Alt><Tab>") # switch back to g-s-m

        #have to click there somewhere already due to a bug #723448
        clickProcess(sysmon)
        sysmon.clickMenu((('View','menu'), ('Active Processes', 'check menu item')))
        keyCombo('<Esc>')
        sleep(10) # for list to reload
        clickProcess(sysmon, str(root_pid)) # will click at root p.
        sysmon.clickMenu((('Edit','menu'), ('Kill Process', 'menu item')))
        sleep(3)
        keyCombo("<Alt>k") # kill it
        sleep(2)
        #keyCombo("<Alt><Tab>") This was necessary on F14, not on RHEL62
        keyCombo("<Alt>c") # cancel the dialog
        #check that the 'Cannot...' message appeared
        sysmon.app.child(name='Error', roleName='alert')
        keyCombo("<Alt>o") #close the message
        sleep(1)
    except Exception:
        printException() # FAIL
        ret_code = 1

    if ret_code is not 0:
        sysmon.kill(force=True)
    else:
        print '------ PASS ------'
    #os.kill(pid, SIGKILL)
    return ret_code
if __name__ == "__main__": sys.exit(main())
